unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MMSystem, ExtCtrls, ComCtrls, Menus, StdCtrls, Sprite;

type
  TGameStatus = (gsTitle, // we
                 gsPlaying, // Ci椤
                 gsSuccess, // Le
                 gsOver, // GAME OVER
                 gsTerminate); // {YN

  TMainForm = class(TForm)
    pnlView: TPanel;
    pbxView: TPaintBox;
    mnuMain: TMainMenu;
    mnuGame: TMenuItem;
    mnuExit: TMenuItem;
    N1: TMenuItem;
    mnuChooseLevel: TMenuItem;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    mnuStartGame: TMenuItem;
    N2: TMenuItem;
    mnuRestart: TMenuItem;
    mnuPrevLevel: TMenuItem;
    mnuNextLevel: TMenuItem;
    N3: TMenuItem;
    tmrTitle: TTimer;
    M1: TMenuItem;
    mnuSuperMode: TMenuItem;
    mnuUnlimitedBullet: TMenuItem;
    N4: TMenuItem;
    mnuDrawLayer1: TMenuItem;
    mnuDrawLayer2: TMenuItem;
    mnuDrawLayer3: TMenuItem;
    mnuDrawLayer4: TMenuItem;
    procedure pbxViewPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnuStartGameClick(Sender: TObject);
    procedure mnuChooseLevelClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuRestartClick(Sender: TObject);
    procedure mnuNextLevelClick(Sender: TObject);
    procedure tmrTitleTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuSuperModeClick(Sender: TObject);
    procedure mnuDrawLayerClick(Sender: TObject);
  private
    FGameStatus: TGameStatus; // CA
    FLevelNo: Integer; // ثed
    FTank: TMyTank; // D
    FETankUsed: Integer; // dwX{ĤZJ
    FScore: Integer; // 
    
    FBackBitmap: TBitmap; // ΨӰ dobule-buffering  bitmap
    
    procedure DrawBackBitmap; // øsI bitmap
    procedure UpdateView; // sCe
    procedure UpdateControlStatus;
    
    // ͼĤZJ_
    procedure CreateETank(Kind: Integer);
    procedure CreateGem(Kind: Integer);
    
    procedure GameLoop; // CDj
    
    // bCeΥWøXrΥ~
    procedure DrawStatusBox(S: string; TopOrCenter: Boolean);
    
    procedure SetGameStatus(Value: TGameStatus);
    procedure SetLevelNo(Value: Integer);
    
    property GameStatus: TGameStatus read FGameStatus write SetGameStatus;
    property LevelNo: Integer read FLevelNo write SetLevelNo;
  public
    { Public declarations }
  end;
  
var
  MainForm: TMainForm;
  
implementation

uses util, tileunit, Mapunit, about, xFiles;

{$R *.DFM}

procedure TMainForm.UpdateView;
begin
  DrawBackBitmap; // eb bitmap
  pbxView.Canvas.Draw(0, 0, FBackBitmap); // AeW
end;

procedure TMainForm.pbxViewPaint(Sender: TObject);
begin
  UpdateView;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FTank := TMyTank.Create; // ͥD
  
  Tiles := TTiles.Create; // ͹Ϯw
  Map := tmap.Create; // da
  try
    FTank.LoadBits; // ŪJDϧ

    Tiles.LoadFromFile(AppDir + FN_TILE_ARCHIVE); // ŪJϮw
  except
    on E: Exception do
      begin
        ShowMessage(E.message);
        PostMessage(Handle, WM_CLOSE, 0, 0); // H asynchronous 覡
      end;
  end;
  
  // ھڱ`ƨӽվ pnlView εjp
  pnlView.ClientWidth := WORLD_WIDTH;
  pnlView.ClientHeight := WORLD_HEIGHT;
  
  ClientWidth := pnlView.Width;
  ClientHeight := pnlView.Height;
  
  FBackBitmap := TBitmap.Create; // wĥ bitmap
  FBackBitmap.Width := WORLD_WIDTH;
  FBackBitmap.Height := WORLD_HEIGHT;
  
  // wƤu@nF, iJ title e
  GameStatus := gsTitle;
end;

// Neøsbwĥ bitmap, AƻsW
procedure TMainForm.DrawBackBitmap;
var
  Str: string;
  R  : TRect;
begin
  if mnuDrawLayer1.Checked then // øsaμh
    Map.DrawMap(LAYER_TERR, FBackBitmap.Canvas)
  else begin // YSeaμh, N
    FBackBitmap.Canvas.Brush.Color := clBlack;
    FBackBitmap.Canvas.FillRect(FBackBitmap.Canvas.ClipRect);
  end;

  if mnuDrawLayer2.Checked then // øsaΪh
    Map.DrawMap(LAYER_TERRITEM, FBackBitmap.Canvas);

  if mnuDrawLayer3.Checked then // øs~h
    Map.DrawMap(LAYER_ITEM, FBackBitmap.Canvas);

  // Y_, eX_
  if Assigned(Gem) then Gem.Draw(FBackBitmap.Canvas);

  DrawTanks(FBackBitmap.Canvas, False); // eXaWҦZJ

  DrawBullets(FBackBitmap.Canvas); // eXlu

  if mnuDrawLayer4.Checked then // øsaΪh
    Map.DrawMap(LAYER_HITERRITEM, FBackBitmap.Canvas);

  // eX"Ť"ҦZJ
  DrawTanks(FBackBitmap.Canvas, True);

  with FBackBitmap.Canvas do
  begin
    Font.Color := clWhite;
    Font.name := 'FixedSys';
    Font.Style := [fsBold];
    Font.Size := 12;
    Brush.Style := bsClear;

    case FGameStatus of
      gsTitle: // eXWDjrΤU誺@̦W
      begin
        R := Rect(0, 0, WORLD_WIDTH,
          WORLD_HEIGHT - TextHeight(''));
        DrawText(Handle, '@: eF', - 1, R,
          DT_BOTTOM or DT_CENTER or DT_SINGLELINE);
        DrawStatusBox('ZJjM', True);
      end;

      gsOver: // Ouch, xXQFΥDF
        DrawStatusBox('ȥ', False);

      else
      begin
        // bkWܥͩROΤ
        {$IFDEF DEBUG}
        Str := Format('(%d, %d) (%d, %d)',[FTank.X, FTank.Y,
          FTank.tile_x, FTank.tile_y]);
        {$ELSE}
        Str := Format('˥ %.2d o %.4d',[FTank.HP, FScore]);
        {$ENDIF}
        TextOut(WORLD_WIDTH - TextWidth(Str) - 5, 5, Str);

        // bWd
        Str := Format(' %d',[FLevelNo]);
        TextOut(5, 5, Str);
      end;
    end;

    // Le
    if FGameStatus = gsSuccess then
      DrawStatusBox('Ȧ\ !!', False);
  end;
end;

procedure TMainForm.SetGameStatus(Value: TGameStatus);
var
  I: Integer;
begin
  FGameStatus := Value;

  // ھڷsCA}pɾ
  tmrTitle.Enabled := FGameStatus = gsTitle;

  case FGameStatus of
    gsTitle:
    begin
      LevelNo := 1; // weܲĤ@a

      // H MAX_TANK_ON_SCREEN ĤZJ
      for I := 1 to MAX_TANK_ON_SCREEN do
        CreateETank(Random(5));

      FTank.Visible := False; // NۤvZJð_
      FTank.Active := False; // ۤvZJn
    end;

    gsPlaying:
    begin
      UpdateControlStatus; // sDCΨ䥦
      UpdateView; // sCe

      GameLoop; // iJCDj (Ci椤@bj餺)
    end;

    gsSuccess:
    begin
    end;
  end;

  if FGameStatus <> gsTerminate then // ϥΪ̬O_ ??
  begin
    UpdateControlStatus; // sDCΨ䥦
    UpdateView; // sCe
  end else
    Close; // 
end;

procedure TMainForm.SetLevelNo(Value: Integer);
begin
  Map.LevelNo := Value; // Jda
  FTank.X := Map.Role_X; // ND\bdwm
  FTank.Y := Map.Role_Y;
  
  FLevelNo := Value;
end;

procedure TMainForm.UpdateControlStatus;
const
  StatusStr: array[TGameStatus] of string = ('Welcome', '', 'Ȧ\ !!', 'Game Over', 'Terminating');
begin
  if FGameStatus <> gsPlaying then
    Caption := Format('%s - %s',[Application.Title, StatusStr[FGameStatus]])
  else
    Caption := Format('%s -  %d',[Application.Title, FLevelNo]);
  
  // }UPબA
  mnuRestart.Enabled := FGameStatus = gsPlaying;
  mnuStartGame.Enabled := FGameStatus <> gsPlaying;
  
  mnuPrevLevel.Enabled := (FGameStatus = gsPlaying) and (LevelNo > 1);
  mnuNextLevel.Enabled := (FGameStatus = gsPlaying);
end;

// øXAخ, Pɦb̭gr
procedure TMainForm.DrawStatusBox(S: string; TopOrCenter: Boolean);
var
  R       : TRect;
  TextSize: TSize;
begin
  with FBackBitmap, FBackBitmap.Canvas do
  begin
    Font.Color := clWhite; // r
    Font.name := 'FixedSys';
    Font.Style := [fsBold];
    Font.Size := 20;
    
    TextSize := TextExtent(S);
    // first calculate the necessary rectangle
    R := Rect(0, 0, TextSize.cx, TextSize.cy);
    OffsetRect(R, (Width - TextSize.cx) div 2, (Height - TextSize.cy) div 2); // Nخظme
    
    if TopOrCenter then
    begin
      R.Top := 24; // Nخ\bW褤
      R.Bottom := R.Top + TextSize.cy;
    end;
    
    InflateRect(R, 10, 10); // yø~, e׬ 10
    Pen.Width := 4;
    Pen.Color := clWhite;
    Pen.Style := psSolid;
    Brush.Color := clBlue;
    Brush.Style := bsSolid;
    Rectangle(R.Left, R.Top, R.Right, R.Bottom);
    // NreX, m
    DrawText(Canvas.Handle, PChar(S), Length(S), R, DT_CENTER or DT_SINGLELINE or DT_VCENTER);
  end;
end;

procedure TMainForm.mnuStartGameClick(Sender: TObject);
begin
  LevelNo := LevelNo;
  GameStatus := gsPlaying;
end;

// ϥΪ̿d
procedure TMainForm.mnuChooseLevelClick(Sender: TObject);
var
  S: string;
begin
  S := IntToStr(FLevelNo);
  if InputQuery(Application.Title, 'Input Scenario No:', S) then
  begin
    LevelNo := StrToInt(S);

    if GameStatus <> gsPlaying then
      GameStatus := gsPlaying
    else
      PostMessage(0, WM_INIT_LEVEL, 0, 0); // }ld
  end;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
    Shift: TShiftState);
begin
  if FGameStatus = gsPlaying then // `N, uCA, L~
  begin
    case Key of
      VK_UP, VK_DOWN, VK_LEFT, VK_RIGHT:
      begin
        case Key of
          VK_UP: FTank.Direction := drUp; // VW
            
          VK_DOWN: FTank.Direction := drDown; // VU
            
          VK_LEFT: FTank.Direction := drLeft; // V
            
          VK_RIGHT: FTank.Direction := drRight; // Vk
        end;
        
        FTank.Active := True; // D}l""
      end;
      
      VK_SPACE:
      begin
        FTank.FireBullet; // oglu,  ~~
      end;
    end;
  end;
end;

procedure TMainForm.mnuAboutClick(Sender: TObject);
begin
  with TAboutBox.Create(self) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TMainForm.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.mnuRestartClick(Sender: TObject);
begin
  LevelNo := LevelNo;
  PostMessage(0, WM_INIT_LEVEL, 0, 0); // s}ld
end;

procedure TMainForm.mnuNextLevelClick(Sender: TObject);
begin
  case (Sender as TComponent).Tag of
    0: LevelNo := LevelNo - 1;
    1: LevelNo := LevelNo + 1;
  end;
  PostMessage(0, WM_INIT_LEVEL, 0, 0); // }lsd
end;

// weɨϥΪpɾ, C 10 @Is@
procedure TMainForm.tmrTitleTimer(Sender: TObject);
begin
  // ʩZJΤlu
  MoveTanks;
  MoveBullets;
  
  UpdateView; // se
end;

// ͼĤZJ
procedure TMainForm.CreateETank(Kind: Integer);
type
  TETankClass = class of TETank; // metaclass
const
  ETankClasses: array[0..4] of TETankClass =
    (TETank1, TETank2, TETank3, TETank4, TETank5);
var
  ETank: TETank;
begin
  Inc(FETankUsed); // WdwͪĤZJ

  //  metaclass ܼƫإ߷sĤZJ
  ETank := ETankClasses[Kind].Create;
  ETank.LoadBits;
end;

// _
procedure TMainForm.CreateGem(Kind: Integer);
begin
  Gem := TGem.Create(TGemKind(Kind));
  Gem.LoadBits;
  Gem.RandomPosition; // HN\m
  // _X{ 30 ۰ʮ
  SetTimer(Handle, TIMER_ID_GEM, 30 * 1000, nil);
end;

procedure TMainForm.GameLoop;
var
  bStopEnemy: Boolean; // O_ȰĤ

  // d}lelʧ@
  procedure InitLevel;
  begin
    FScore := 0;
    FETankUsed := 0;

    // DX{, 
    FTank.Visible := True;
    FTank.Active := False;
    FTank.Speed := MYTANK_DEFAULT_SPEED;
    FTank.ResetStatus;

    {$IFDEF DEBUG} // ծD
    FTank.MaxBulletNum := 100;
    FTank.HP := 100;
    {$ENDIF}

    // ثeﶵ]wZJA
    FTank.SuperMode := mnuSuperMode.Checked; // LļҦ
    if mnuUnlimitedBullet.Checked then // solu
      FTank.MaxBulletNum := 100
    else
      FTank.MaxBulletNum := 1;

    // N{slu, ĤZJ_
    FreeBullets;
    FreeTanks;
    if Assigned(Gem) then Gem.Free;

    // nȰĤH
    bStopEnemy := False;

    // NҦpɾ
    KillTimer(Handle, TIMER_ID_GEM);
    KillTimer(Handle, TIMER_ID_GEM_HAT);
    KillTimer(Handle, TIMER_ID_GEM_HAT);
    KillTimer(Handle, TIMER_ID_GEM_ARROW);
  end;

var
  Msg      : TMsg;
  iStopTime: Integer;
begin
  InitLevel; // l

  // Cj
  while (FGameStatus = gsPlaying) do
  begin
    if PeekMessage(Msg, 0, 0, 0, PM_REMOVE) then // oT
    begin
      case Msg.message of
        WM_QUIT: // {, }Cj
        begin
          FGameStatus := gsTerminate;
          Break;
        end;

        WM_DESTROY_OBJECT: // nDY
        begin
          if TObject(Msg.WPARAM) = FTank then // YOD
          begin
            FTank.Visible := False;
            FGameStatus := gsOver; // Game over o ~~
            Break; // }Cj
          end;

          // YQROĤZJ, h Msg.LPARAM N
          Inc(FScore, Msg.LPARAM);

          // NZJPP䦳YluѰY
          FreeBulletsForTank(TTank(Msg.WPARAM));

          // 񪫥
          TObject(Msg.WPARAM).Free;

          // YĤZJX{BF, hU@h
          if (FETankUsed = MAX_ETANK_PER_SCENARIO) and (Length(Tanks) = 1) then
          begin
            // oӥ[@ǹLe...
            LevelNo := LevelNo + 1;
            InitLevel;
          end;
        end;

        WM_GAMEOVER: // xXQF, C
        begin
          FGameStatus := gsOver;
          Break;
        end;

        WM_SPECIAL_CONDITION: // iJSA
        begin
          iStopTime := 10; // SAw]ĮɶQ

          case Msg.WPARAM of
            TIMER_ID_GEM_CLOCK: bStopEnemy := True;// ȰĤH

            TIMER_ID_GEM_HAT: FTank.SuperMode := True; // L

            TIMER_ID_GEM_ARROW:
            begin   // bxXP\W}K, B״_
              Map[LAYER_TERRITEM, 5, 11].TileNo := 3;
              Map[LAYER_TERRITEM, 5, 11].DisposeBreakMap;
              Map[LAYER_TERRITEM, 6, 11].TileNo := 3;
              Map[LAYER_TERRITEM, 6, 11].DisposeBreakMap;
              Map[LAYER_TERRITEM, 7, 11].TileNo := 3;
              Map[LAYER_TERRITEM, 7, 11].DisposeBreakMap;
              Map[LAYER_TERRITEM, 5, 12].TileNo := 3;
              Map[LAYER_TERRITEM, 5, 12].DisposeBreakMap;
              Map[LAYER_TERRITEM, 7, 12].TileNo := 3;
              Map[LAYER_TERRITEM, 7, 12].DisposeBreakMap;

              iStopTime := 20; // KGQ
            end;
          end;
          // ]wpɾ
          SetTimer(Handle, Msg.WPARAM, iStopTime * 1000, nil);
        end;

        WM_TIMER: // pɾɶ (SAɶ)
        begin
          KillTimer(Handle, Msg.WPARAM); // pɾ

          case Msg.WPARAM of
            TIMER_ID_GEM: // _\[F, ٤Y, 
              if Assigned(Gem) then Gem.Free;

            TIMER_ID_GEM_CLOCK: bStopEnemy := False;

            TIMER_ID_GEM_HAT:
              FTank.SuperMode := mnuSuperMode.Checked;

            TIMER_ID_GEM_ARROW: // bxXP\^j
            begin
              Map[LAYER_TERRITEM, 5, 11].TileNo := 2;
              Map[LAYER_TERRITEM, 6, 11].TileNo := 2;
              Map[LAYER_TERRITEM, 7, 11].TileNo := 2;
              Map[LAYER_TERRITEM, 5, 12].TileNo := 2;
              Map[LAYER_TERRITEM, 7, 12].TileNo := 2;
            end;
          end;
        end;

        WM_INIT_LEVEL:
        begin
          InitLevel; // ds}l
        end;
      end;

      // `TBz{
      TranslateMessage(Msg);
      DispatchMessage(Msg);
    end else if Focused then // Y֦JJI~ʧ@
    begin       
      // YdΥثeĤZJSFW,
      // hӶü"i"X{ĤZJ
      if (FETankUsed < MAX_ETANK_PER_SCENARIO) and
        (Length(Tanks) < MAX_TANK_ON_SCREEN) and
        (Random < PROBAB_ETANK_BORN) then
        CreateETank(Random(5)); // ةZJ@

      // YثeS_, hӶü"i"X{_
      if not Assigned(Gem) and (Random < PROBAB_GEM_BORN) then
        CreateGem(Random(6)); // _@

      // ʧڤZJΡμĤZJ
      if bStopEnemy then
        FTank.Move
      else
        MoveTanks;

      // ʤlu
      MoveBullets;

      // se
      UpdateView;
    end else begin
      // YSoJJI, hNv浹䥦,
      // 즳Ti
      WaitMessage;
    end;
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  // Ҧ귽
  FBackBitmap.Free;
  FTank.Free;
  Tiles.Free;
  Map.Free;
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word;
    Shift: TShiftState);
begin
  // `N, uCA, L~
  if FGameStatus = gsPlaying then
  begin
    case Key of // }L, ڤZJNʧ@
      VK_UP, VK_DOWN, VK_LEFT, VK_RIGHT: FTank.Active := False;
    end;
  end;
end;

procedure TMainForm.mnuSuperModeClick(Sender: TObject);
begin
  with (Sender as TMenuItem) do
  begin
    Checked := not Checked;

    case Tag of
      0: FTank.SuperMode := Checked; // LļҦ

      1: if Checked then // solu
        FTank.MaxBulletNum := 100
      else
        FTank.MaxBulletNum := 1;
    end;
  end;
end;

procedure TMainForm.mnuDrawLayerClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked;
end;

initialization
  Randomize; // üƺؤl

end.

