unit sprite;

interface

uses Windows, MMSystem, SysUtils, Graphics, Classes, Math, mapunit, util;

type
  TDirection = (drUp, drDown, drLeft, drRight); // V

  // ݩ
  TSpriteAttr = set of (
    saUndirectionalBitmap, // ϧΤV
    saNoCellCollision, // ϮI
    saNoTankCollision, // ZJI
    saNoBulletCollision, // luI
    saAlignWithTerrItem); // ʮɷ|۰ʹaΪ, _Ӥ

  // ʵeO_έY}l
  TAdvanceFrameMode = (afWrap, afStop);

  // _
  TGemKind = (gkClock, gkHat, gkArrow, gkStar, gkBlow, gkApple);

  // forward declaration
  TTank = class;
  TBullet = class;
  TGem = class;

  // Ǧ^IG}CA
  TCellArray = array of TCell;
  TTankArray = array of TTank;
  TBulletArray = array of TBullet;

  // beW樫ʪ⪫
  TSprite = class
  private
    FX, fy: Integer; // y
    FFrameNo: Integer; // ثeܪ frame s
    FSpeed: Integer; // it
    FCollisionCount: Integer; // sI
    FMoveDelay, FMoveDelayCount: Integer; // Uʧ@e𦸼

    FActive: Boolean; // O_iʧ@
    FVisible: Boolean; // O_i
    FOnAir: Boolean; // O_bѪ
    FPostToDead: Boolean; // O_wnOnR

    FRect: TRect; // ίxΰϰ
    FDirection: TDirection; // iV
    FAttr: TSpriteAttr; // ݩ
    FAdvanceFrameMode: TAdvanceFrameMode; // ʵeBz覡

    FBits, FInvBitmap: TBitmap; // ϤζKϥιϤ

    // ⤤IҦbϮm
    function GetTile_X: Integer;
    function GetTile_Y: Integer;

    // o⪺eΰ
    function GetObjectWidth: Integer;
    function GetObjectHeight: Integer;

    procedure SetDirection(Value: TDirection);
  protected
    // oϧɦW
    function GetFileName: string; virtual; abstract;
    // oʵeؼ
    function GetFrameMax: Integer; virtual; abstract;
    // oؤo
    function GetObjectRect: TRect; virtual;

    // IˬdĲok, tdIsҦIˬdk
    function CheckCollisions(var X, Y: Integer): Boolean; virtual;

    // ɸIˬd
    procedure CheckBoundCollisions(var X, Y: Integer;
      var bCollision: Boolean); virtual;
    // aΪIˬd
    function CheckCellCollisions(Layer: Integer; var X, Y: Integer;
      var bCollision: Boolean): TCellArray; virtual;
    // ZJIˬd
    function CheckTankCollisions(var X, Y: Integer;
      var bCollision: Boolean): TTankArray; virtual;
  public
    constructor Create; virtual;
    destructor Destroy; override;

    procedure LoadBits; // Jϧ

    procedure Draw(Canvas: TCanvas); virtual; // øs

    procedure Move; virtual; // iU@Bʧ@

    procedure PostToDie(Param: WPARAM = 0); // nOR

    procedure RandomDirection; // HNܤV
    procedure RandomPosition; // HN\m
    procedure CenterWith(ASprite: TSprite); // Pt@m
    procedure CenterBy(X, Y: Integer); // ϤI (X, Y)

    property X: Integer read FX write FX;
    property Y: Integer read fy write fy;

    property Tile_X: Integer read GetTile_X;
    property Tile_Y: Integer read GetTile_Y;

    property Direction: TDirection read FDirection write SetDirection;
    property Speed: Integer read FSpeed write FSpeed;
    property Active: Boolean read FActive write FActive;
    property Visible: Boolean read FVisible write FVisible;
    property OnAir: Boolean read FOnAir write FOnAir;

    property Rect: TRect read FRect;
    property Attr: TSpriteAttr read FAttr write FAttr;

    property ObjectRect: TRect read GetObjectRect;
    property ObjectWidth: Integer read GetObjectWidth;
    property ObjectHeight: Integer read GetObjectHeight;
  end;

  // ZJO, ڤμĤZJұqO~
  TTank = class(TSprite)
  private
    FHP: Integer; // ˥ (ͩRO)
    FScore: Integer; // QR, Do
    FBulletNum: Integer; // ثelu
    FMaxBulletNum: Integer; //   P@ɶluƤW
    FBulletBlowRange: Integer; // luz¤O (d)

    FSuperMode: Boolean; // LļҦ
  protected
    function GetFrameMax: Integer; override;

    // gZJIˬd
    function CheckTankCollisions(var X, Y: Integer;
      var bCollision: Boolean): TTankArray; override;
  public
    constructor Create; override;
    destructor Destroy; override;

    procedure ResetStatus; virtual; // ]ZJA
    function FireBullet: TBullet; virtual; // oglu

    property HP: Integer read FHP write FHP;
    property MaxBulletNum: Integer read FMaxBulletNum
      write FMaxBulletNum;
    property SuperMode: Boolean read FSuperMode write FSuperMode;
  end;

  // ڤZJO
  TMyTank = class(TTank)
  protected
    function GetFileName: string; override;

    // gIˬdĲok
    function CheckCollisions(var X, Y: Integer): Boolean; override;

    // _Iˬd
    function CheckGemCollisions(var X, Y: Integer; var bCollision: Boolean): TGem; virtual;
  public
    constructor Create; override;

    procedure ResetStatus; override; // ]ZJA
  end;

  // ĤZJXͮɪ{{ĪGO
  TStar = class(TSprite)
  protected
    function GetFileName: string; override;
    function GetFrameMax: Integer; override;
    function GetObjectRect: TRect; override;
  public
    constructor Create; override;
  end;
  
  // ĤZJO, |bXͮɥQ TStar Osy{{ĪG
  TETank = class(TTank)
  private
    FStar: TStar; // ҨϥΪ{{ 
  protected
    function GetFrameMax: Integer; override;
  public
    constructor Create; override;
    
    procedure Draw(Canvas: TCanvas); override;
    procedure Move; override;
  end;
  
  // HUOؼĤZJO
  TETank1 = class(TETank)
  protected
    function GetFileName: string; override;
  public
    constructor Create; override;
  end;
  
  TETank2 = class(TETank)
  protected
    function GetFileName: string; override;
  public
    constructor Create; override;
  end;
  
  TETank3 = class(TETank)
  protected
    function GetFileName: string; override;
  public
    constructor Create; override;
    
    function FireBullet: TBullet; override;
  end;
  
  TETank4 = class(TETank)
  protected
    function GetFileName: string; override;
  public
    constructor Create; override;
  end;
  
  TETank5 = class(TETank)
  protected
    function GetFileName: string; override;
    function GetFrameMax: Integer; override;
    function GetObjectRect: TRect; override;
  public
    constructor Create; override;
  end;
  
  // zĪGO, HO
  TExplosion = class(TSprite)
  private
    FLeadToOver: Boolean; // ||ɭP Game Over
  public
    constructor Create; override;
  end;
  TExplosionClass = class of TExplosion;
  
  // ɤΦaΪpz
  TSmallExplosion = class(TExplosion)
  protected
    function GetFileName: string; override;
    function GetFrameMax: Integer; override;
  end;
  
  // ZJjz
  TBigExplosion = class(TExplosion)
  protected
    function GetFileName: string; override;
    function GetFrameMax: Integer; override;
    function GetObjectRect: TRect; override;
  end;
  
  // luO, luѩZJ, FFۦR
  TBullet = class(TSprite)
  private
    FTank: TTank; // ͦluZJ
    FExplosion: TExplosion; // luҲͪz
    FTankBulletNum_Dropped: Boolean; // O_wNZJluƥػ

    // ҰzĪG (إz)
    procedure FireExplosion(ExplosionClass: TExplosionClass);
    procedure LocateExplosion(R: TRect); // Nzmxΰϰ줤
  protected
    function GetFileName: string; override;
    function GetFrameMax: Integer; override;
    function GetObjectRect: TRect; override;

    // gIˬdĲok
    function CheckCollisions(var X, Y: Integer): Boolean; override;

    // gҦIBzk, PɷsWPluIBzk
    procedure CheckBoundCollisions(var X, Y: Integer;
      var bCollision: Boolean); override;
    function CheckCellCollisions(Layer: Integer; var X, Y: Integer;
       var bCollision: Boolean): TCellArray; override;
    function CheckTankCollisions(var X, Y: Integer;
      var bCollision: Boolean): TTankArray; override;
    function CheckBulletCollisions(var X, Y: Integer;
      var bCollision: Boolean): TBulletArray; virtual;
  public
    constructor Create(ATank: TTank);
    destructor Destroy; override;

    procedure Draw(Canvas: TCanvas); override;
    procedure Move; override;
  end;

  // _O, |wɥX{beW
  TGem = class(TSprite)
  private
    FGemKind: TGemKind; // _
  protected
    function GetFileName: string; override;
    function GetFrameMax: Integer; override;
  public
    constructor Create(AGemKind: TGemKind);
    destructor Destroy; override;
  end;
  
  // ZJBz禡 (, øs, )
procedure MoveTanks;
procedure DrawTanks(Canvas: TCanvas; OnAir: Boolean);
procedure FreeTanks;

// luBz禡 (, øs, )
procedure MoveBullets;
procedure DrawBullets(Canvas: TCanvas); // øsҦlu
procedure FreeBullets;
procedure FreeBulletsForTank(ATank: TTank);

var
  Tanks  : array of TTank;   // ҦZJ ( ]AڤZJ )
  Bullets: array of TBullet; // Ҧlu
  Gem    : TGem;             // _ (P@ɶu@)
  
implementation

uses tileunit, xFiles, xDArray;

constructor TSprite.Create;
begin
  inherited Create;
  
  // l
  FX := 0;
  fy := 0;
  FFrameNo := 0;

  FMoveDelay := 0;
  FMoveDelayCount := 0;
  
  FActive := True;
  FVisible := True;
  FPostToDead := False;
  FOnAir := False;
  
  FAttr := [];
  FAdvanceFrameMode := afWrap;
  FSpeed := SPRITE_DEFAULT_SPEED;
  
  // ⪺ bitmap
  FBits := TBitmap.Create;

  // zKϥΪ bitmap
  FInvBitmap := TBitmap.Create;
  FInvBitmap.Width := ObjectWidth;
  FInvBitmap.Height := ObjectHeight;
  FInvBitmap.Transparent := True;
  FInvBitmap.TransparentColor := TRANSPARENT_COLOR;
end;

destructor TSprite.Destroy;
begin
  FInvBitmap.Free;
  FBits.Free;

  inherited Destroy;
end;

procedure TSprite.LoadBits;
begin
  FBits.LoadFromFile(GetFileName); // Ū BMP 

  // ˬdJ bitmap ؤoO_Xk
  if not (saUndirectionalBitmap in Attr) then
    if FBits.Width < ObjectWidth * 4 then // |ӤV
      raise Exception.Create('Width of bitmap is invalid');

  if FBits.Height < ObjectHeight * (GetFrameMax + 1) then
    raise Exception.Create('Height of bitmap is invalid');
end;

procedure TSprite.Draw(Canvas: TCanvas);
begin
  //YiΤwnORhe
  if not FVisible or FPostToDead then Exit;

  // ʵeؽsXkhe
  if (FFrameNo > GetFrameMax) or (FFrameNo < 0) then Exit;

  // NnqXϰ FInvBitmap
  // Yu@iϧ, V
  if saUndirectionalBitmap in FAttr then
    FInvBitmap.Canvas.CopyRect(ObjectRect, FBits.Canvas,
    Classes.Rect(0, FFrameNo * ObjectHeight, ObjectWidth,
    (FFrameNo + 1) * ObjectHeight))
  else  // ̥ثeV
    FInvBitmap.Canvas.CopyRect(ObjectRect, FBits.Canvas,
      Classes.Rect(Ord(FDirection) * ObjectWidth,
      FFrameNo * ObjectHeight, (Ord(FDirection) + 1) * ObjectWidth,
      (FFrameNo + 1) * ObjectHeight));

  // AeX FInvBitmap
  Canvas.Draw(FX, fy, FInvBitmap);
end;

procedure TSprite.CheckBoundCollisions(var X, Y: Integer; 
  var bCollision: Boolean);
var
  OrgX, OrgY: Integer;
begin
  // ˬd
  OrgX := X; OrgY := Y;
  if Y < 0 then Y := 0; // O_WXW
  if X < 0 then X := 0; // O_WX
  if X + ObjectWidth >= WORLD_WIDTH then // O_WXk
    X := WORLD_WIDTH - ObjectWidth;
  if Y + ObjectHeight >= WORLD_HEIGHT then // O_WXU
    Y := WORLD_HEIGHT - ObjectHeight;

  // O_ ?
  if (OrgX <> X) or (OrgY <> Y) then bCollision := True;
end;

function TSprite.CheckCellCollisions(Layer: Integer; var X, Y: Integer; var bCollision: Boolean): TCellArray;
var
  NewRect: TRect;
  
  function IsRealCellCollision(CellXPos, CellYPos: Integer): Boolean;
  begin
    Result := False;
    
    // P_O_uIaΪ
    case FDirection of
      drUp:
      begin
        if CellYPos <> Tile_Y + 1 then // VWɤi]IUa
        begin
          Y := Map[Layer, CellXPos, CellYPos].Rect.Bottom;
          Result := True;
        end;
      end;

      drDown:
      begin
        if CellYPos <> Tile_Y - 1 then
        begin
          Y := Map[Layer, CellXPos, CellYPos].Rect.Top - ObjectHeight;
          Result := True;
        end;
      end;
      
      drLeft:
      begin
        if CellXPos <> Tile_X + 1 then
        begin
          X := Map[Layer, CellXPos, CellYPos].Rect.Right;
          Result := True;
        end;
      end;

      drRight:
      begin
        if CellXPos <> Tile_X - 1 then
        begin
          X := Map[Layer, CellXPos, CellYPos].Rect.Left - ObjectWidth;
          Result := True;
        end;
      end;
    end;
    
    // ʮɦ۰ʹaΪ, _Ӥ    
    if Result and (saAlignWithTerrItem in FAttr) then
      case FDirection of
        drUp, drDown:
        begin
          if (CellXPos = Tile_X) and (Abs(X + ObjectWidth - Map[Layer, CellXPos, CellYPos].Rect.Left) <= SMOOTH_MOVE_THRESHOLD) then
            X := Map[Layer, CellXPos, CellYPos].Rect.Left - ObjectWidth
          else if (CellXPos = Tile_X) and (Abs(X - Map[Layer, CellXPos, CellYPos].Rect.Right) <= SMOOTH_MOVE_THRESHOLD) then
            X := Map[Layer, CellXPos, CellYPos].Rect.Right
          else if (CellXPos = Tile_X - 1) and (Abs(X - TILEWIDTH[Tile_X]) <= SMOOTH_MOVE_THRESHOLD) and Map[Layer, Tile_X, Tile_Y].CanPass then
            X := TILEWIDTH[Tile_X]
          else if (CellXPos = Tile_X + 1) and (Abs(X + ObjectWidth - TILEWIDTH[CellXPos]) <= SMOOTH_MOVE_THRESHOLD) and Map[Layer, CellXPos - 1, Tile_Y].CanPass then
            X := TILEWIDTH[CellXPos] - ObjectWidth;
        end;
        
        drLeft, drRight:
        begin
          if (CellYPos = Tile_Y) and (Abs(Y + ObjectHeight - Map[Layer, CellXPos, CellYPos].Rect.Top) <= SMOOTH_MOVE_THRESHOLD) then
            Y := Map[Layer, CellXPos, CellYPos].Rect.Top - ObjectHeight
          else if (CellYPos = Tile_Y) and (Abs(Y - Map[Layer, CellXPos, CellYPos].Rect.Bottom) <= SMOOTH_MOVE_THRESHOLD) then
            Y := Map[Layer, CellXPos, CellYPos].Rect.Bottom
          else if (CellYPos = Tile_Y - 1) and (Abs(Y - TILEHeight[Tile_Y]) <= SMOOTH_MOVE_THRESHOLD) and Map[Layer, Tile_X, Tile_Y].CanPass then
            Y := TILEHeight[Tile_Y]
          else if (CellYPos = Tile_Y + 1) and (Abs(Y + ObjectHeight - TILEHeight[CellYPos]) <= SMOOTH_MOVE_THRESHOLD) and Map[Layer, Tile_X, CellYPos - 1].CanPass then
            Y := TILEHeight[CellYPos] - ObjectHeight;
        end;
      end;
  end;
  
  procedure CheckCellCollisionsPos(XPos, YPos: Integer);
  var
    R: TRect;
  begin
    if (XPos < 0) or (YPos < 0) or (XPos >= TILE_NUM_X) or (YPos >= TILE_NUM_Y) then
      Exit;
    
    // NqLa Cell [JIG}C
    if not Map[Layer, XPos, YPos].CanPass and
      (IntersectRect(R, NewRect, Map[Layer, XPos, YPos].Rect)) and
      IsRealCellCollision(XPos, YPos) then
    begin
      SetLength(Result, Length(Result) + 1);
      Result[Length(Result) - 1] := Map[Layer, XPos, YPos];
    end;
  end;

var
  tX, ty: Integer;
begin
  NewRect := ObjectRect;
  OffsetRect(NewRect, X, Y);
  
  tX := (X + ObjectWidth div 2) div TILE_WIDTH;
  ty := (Y + ObjectHeight div 2) div TILE_Height;
  
  // OըPKϮΥҦbϮ, O_o͸I
  dec(tX); dec(ty);
  CheckCellCollisionsPos(tX, ty); // (tx-1, ty-1)

  Inc(tX);
  CheckCellCollisionsPos(tX, ty); // (tx, ty-1)

  Inc(tX);
  CheckCellCollisionsPos(tX, ty); // (tx+1, ty-1)

  Inc(ty);
  CheckCellCollisionsPos(tX, ty); // (tx+1, ty)

  dec(tX);
  CheckCellCollisionsPos(tX, ty); // (tx, ty)

  dec(tX);
  CheckCellCollisionsPos(tX, ty); // (tx-1, ty)

  Inc(ty);
  CheckCellCollisionsPos(tX, ty); // (tx-1, ty+1)
  
  Inc(tX);
  CheckCellCollisionsPos(tX, ty); // (tx, ty+1)

  Inc(tX);
  CheckCellCollisionsPos(tX, ty); // (tx+1, ty+1)

  bCollision := Length(Result) > 0; // Io
end;

function TSprite.CheckTankCollisions(var X, Y: Integer;
  var bCollision: Boolean): TTankArray;
var
  I         : Integer;
  NewRect, R: TRect;
begin
  // psxΰϰ
  NewRect := ObjectRect;
  OffsetRect(NewRect, X, Y);

  // @@MXeWҦZJ
  for I := 0 to Length(Tanks) - 1 do
    if (Self <> Tanks[I]) and (not Tanks[I].FPostToDead) and
      IntersectRect(R, NewRect, Tanks[I].Rect) then
    begin
      // N쪺ZJ[JIG}C
      SetLength(Result, Length(Result) + 1);
      Result[Length(Result) - 1] := Tanks[I];
    end;

  bCollision := Length(Result) > 0; // Io
end;

// (X, Y) OϥΪsy, Ǧ^ȪܬO_oͥI
function TSprite.CheckCollisions(var X, Y: Integer): Boolean;
begin
  Result := False; // ]SIF
  
  // ˬdO_ZJ
  if not (saNoTankCollision in FAttr) then
  begin
    CheckTankCollisions(X, Y, Result);
    if Result then Exit;
  end;
  
  // ˬdO_aΪ
  if not (saNoCellCollision in FAttr) then
  begin
    CheckCellCollisions(LAYER_TERRITEM, X, Y, Result);
    if Result then Exit;
  end;

  // ˬdO_
  CheckBoundCollisions(X, Y, Result);
  if Result then Exit;
end;

// ̭nʧ@禡, ⪺ʧ@
procedure TSprite.Move;
var
  X, Y: Integer;
begin
  if FPostToDead then Exit; // wgnOǳƳQRF
  if not FActive then Exit; // iʧ@

  // Cʧ@e𦸼
  if (FMoveDelay <> 0) then
  begin
    // C FMoveDelay ~u Move @
    Inc(FMoveDelayCount);
    if FMoveDelayCount <> FMoveDelay then Exit;
    FMoveDelayCount := 0; // ks
  end;

  if GetFrameMax > 0 then // Yʵe
  begin
    Inc(FFrameNo); // Wʵes
    if FFrameNo > GetFrameMax then // @ӽjF
    begin
      if FAdvanceFrameMode = afWrap then FFrameNo := 0 // sA
      else
      begin
        FFrameNo := GetFrameMax;  // b̫@iʵe
        FActive := False; // ʧ@
      end;
    end;
  end;

  if FSpeed = 0 then Exit; // Yt׬s, 

  X := FX; Y := fy;
  // pU@Bm
  case FDirection of
    drUp: dec(Y, FSpeed); // W
    drDown: Inc(Y, FSpeed); // U
    drLeft: dec(X, FSpeed); // 
    drRight: Inc(X, FSpeed); // k
  end;

  // ˬdҦI
  if CheckCollisions(X, Y) then
    Inc(FCollisionCount) //  줰FF...
  else
    FCollisionCount := 0; // 򳣨S, sIpƾks

  FX := X; // sm
  fy := Y;

  // sΪxΰϰ
  FRect := ObjectRect;
  OffsetRect(FRect, FX, fy);
end;

// HNܤV
procedure TSprite.RandomDirection;
begin
  Direction := TDirection(Random(Ord(High(TDirection)) + 1));
end;

// HN\m
procedure TSprite.RandomPosition;
begin
  FX := Random(WORLD_WIDTH - ObjectWidth);
  fy := Random(WORLD_HEIGHT - ObjectHeight);
  
  FRect := ObjectRect;
  OffsetRect(FRect, FX, fy);
end;

// Pt@m
procedure TSprite.CenterWith(ASprite: TSprite);
begin
  FX := ASprite.FX + ASprite.ObjectWidth div 2 - ObjectWidth div 2;
  fy := ASprite.fy + ASprite.ObjectHeight div 2 - ObjectHeight div 2;
  
  FRect := ObjectRect;
  OffsetRect(FRect, FX, fy);
end;

// ϤI (X, Y)
procedure TSprite.CenterBy(X, Y: Integer);
begin
  FX := X - ObjectWidth div 2;
  fy := Y - ObjectHeight div 2;
  
  FRect := ObjectRect;
  OffsetRect(FRect, FX, fy);
end;

function TSprite.GetTile_X: Integer;
begin
  Result := (FX + ObjectWidth div 2) div TILE_WIDTH;
end;

function TSprite.GetTile_Y: Integer;
begin
  Result := (fy + ObjectHeight div 2) div TILE_Height;
end;

// oe
function TSprite.GetObjectWidth: Integer;
begin
  with GetObjectRect do
    Result := Right - Left;
end;

// oⰪ
function TSprite.GetObjectHeight: Integer;
begin
  with GetObjectRect do
    Result := Bottom - Top;
end;

procedure TSprite.SetDirection(Value: TDirection);
begin
  if Value <> FDirection then
  begin
    FCollisionCount := 0; // V, sIks
    FDirection := Value;
  end;
end;

function TSprite.GetObjectRect: TRect;
begin
  Result := TILE_RECT;
end;

// nOR
procedure TSprite.PostToDie(Param: WPARAM = 0);
begin
  if FPostToDead then Exit; // еnO
  
  // ǰe WM_DESTROY_OBJECT TΥ}, ѹCjBz
  PostMessage(0, WM_DESTROY_OBJECT, WPARAM(Self), Param);
  FPostToDead := True;
end;

{ TTank abstract class }

constructor TTank.Create;
begin
  inherited Create;
  
  ResetStatus; // mZJA (ͩRO, t, )
  
  // N[J Tanks }C
  SetLength(Tanks, Length(Tanks) + 1);
  Tanks[Length(Tanks) - 1] := Self;
end;

destructor TTank.Destroy;
var
  I: Integer;
begin
  // N Tanks }C (FڤZJ)
  for I := 1 to Length(Tanks) - 1 do
    if Tanks[I] = Self then
    begin
      DynArrayDelete(Tanks, sizeof(TTank), I, 1);
      Break;
    end;
  
  inherited Destroy;
end;

function TTank.GetFrameMax: Integer;
begin
  Result := 1;
end;

// oglu, Ǧ^ȬogXhlu
function TTank.FireBullet: TBullet;
begin
  Result := nil;

  // ثeluƭYwFWhe\Aog
  if FBulletNum >= FMaxBulletNum then Exit;

  Result := TBullet.Create(Self); // إߤlu
  Result.LoadBits; // Jluϧ
  Result.Direction := FDirection; // luPZJPˤV
  Result.Speed := BULLET_DEFAULT_SPEED;

  Result.CenterWith(Self); // Nluyг]wPZJm

  case FDirection of // ھڦiVӽվluy
    drUp: Result.Y := Rect.Top;
    drDown: Result.Y := Rect.Bottom - Result.ObjectHeight;
    drLeft: Result.X := Rect.Left;
    drRight: Result.X := Rect.Right - Result.ObjectWidth;
  end;

  Inc(FBulletNum); // WZJثelu
end;

function TTank.CheckTankCollisions(var X, Y: Integer; var bCollision: Boolean): TTankArray;
var
  I: Integer;
begin
  // Isl CheckTankCollisions koIZJC
  Result := inherited CheckTankCollisions(X, Y, bCollision);

  if bCollision then // YPZJo͸I
  begin
    I := 0;
    while I < Length(Result) do // M"|IZJ"ZJ
      if (saNoTankCollision in Result[I].FAttr) then
        DynArrayDelete(Result, sizeof(TTank), I, 1)
      else
        Inc(I);

    bCollision := Length(Result) > 0; // sMO_o͸I
    if not bCollision then Exit; // `ϸɨc, ӵo͸I..
    
    // ھڸI쪺ZJΦۤvVӽվy
    for I := 0 to Length(Result) - 1 do
      case FDirection of
        drUp: Y := Result[I].Rect.Bottom; // ۤvb誺U
        drDown: Y := Result[I].Rect.Top - ObjectHeight;
        drLeft: X := Result[I].Rect.Right; // ۤvb誺k
        drRight: X := Result[I].Rect.Left - ObjectWidth;
      end;
  end;
end;

// mZJA (ͩRO, t, )
procedure TTank.ResetStatus;
begin
  FSuperMode := False; // `Ҧ
  
  FHP := 1; // Q@N
  
  FMaxBulletNum := 1;
  FBulletNum := 0;
  FBulletBlowRange := BULLET_DEFAULT_BLOW_RANGE;
  
  FPostToDead := False;
  FAttr := [saAlignWithTerrItem]; // ZJ㦳۰ʽվmݩ, _Ӥ
end;

{ TMyTank class }

constructor TMyTank.Create;
begin
  inherited Create;

  FDirection := drUp; // V¤W
end;

procedure TMyTank.ResetStatus;
begin
  inherited ResetStatus;
  
  FSpeed := MYTANK_DEFAULT_SPEED; // ]wڤZJt
end;

function TMyTank.GetFileName: string;
begin
  Result := AppDir + DR_IMAGES + 'mytank.bmp';
end;

function TMyTank.CheckGemCollisions(var X, Y: Integer; var bCollision: Boolean): TGem;
var
  NewRect, R: TRect;
begin
  Result := nil;

  if not Assigned(Gem) then Exit; // _sb

  // ھڷsyЭpZJҦΪxΰϰ
  NewRect := ObjectRect;
  OffsetRect(NewRect, X, Y);

  // ZJO_P_Ҧxΰϰ첣ͥ涰
  if IntersectRect(R, NewRect, Gem.Rect) then
    Result := Gem;

  // L׵G,  bCollision Lܼƪ, ]P_
  // I(Y_)äOuI
end;

function TMyTank.CheckCollisions(var X, Y: Integer): Boolean;
begin
  Result := inherited CheckCollisions(X, Y);

  // pGY_...
  if Assigned(CheckGemCollisions(X, Y, Result)) then
  begin
    // ھ_, ǰeTCjBz, ΦۤvBz
    case Gem.FGemKind of
      gkClock:
      PostMessage(0, WM_SPECIAL_CONDITION, TIMER_ID_GEM_CLOCK, 0);

      gkHat:
      PostMessage(0, WM_SPECIAL_CONDITION, TIMER_ID_GEM_HAT, 0);

      gkArrow:
      PostMessage(0, WM_SPECIAL_CONDITION, TIMER_ID_GEM_ARROW, 0);

      gkStar: FMaxBulletNum := 10; // solu

      gkBlow: FBulletBlowRange := 32; // Wjluz¤O

      gkApple: FSpeed := 2 * MYTANK_DEFAULT_SPEED; // ⭿t
    end;

    Gem.Free; // N_R(QYF)
  end;
end;

{ TStar class }

// ĤZJXͮɪ{{ĪGO
constructor TStar.Create;
begin
  inherited Create;

  FMoveDelay := 8; // CK frame ~ܤ@
  FSpeed := 0; // 
  FAttr := [saUndirectionalBitmap]; // SV
  FAdvanceFrameMode := afStop; // ʵeN
end;

function TStar.GetFileName: string;
begin
  Result := AppDir + DR_IMAGES + 'star.bmp';
end;

function TStar.GetFrameMax: Integer;
begin
  Result := 2; // Tiʵe
end;

function TStar.GetObjectRect: TRect;
begin
  Result := Classes.Rect(0, 0, 38, 32);
end;

{ TETank class }

// ĤZJO,
constructor TETank.Create;
begin
  inherited Create;

  FDirection := drDown; // V@ߴ¤U

  // bTӥXͦaIܤ@ (W, W, kW)
  fy := 0;
  case Random(3) of
    0: FX := 0;
    1: FX := (WORLD_WIDTH - ObjectWidth) div 2;
    2: FX := WORLD_WIDTH - ObjectWidth;
  end;

  // Q TStar Osy{{ĪG
  FStar := TStar.Create;
  FStar.LoadBits;
  FStar.CenterWith(Self);
end;

function TETank.GetFrameMax: Integer;
begin
  Result := 1; // iʵe (CӤV)
end;

// ĤZJʤk
procedure TETank.Move;
begin
  if Assigned(FStar) then // ٦bXͤ..
  begin
    FStar.Move; // {{iU@

    if not FStar.FActive then // Y{{ʵeqF..
    begin
      FStar.Free; // R{{, U@ʼĤZJN|X{F..
      FStar := nil;
    end;
  end else
  begin
    // ̶ü"i"oglu
    if (Random < PROBAB_ETANK_SHOT_BULLET) then
      FireBullet;

    // YsIƹLh, ζüƳ\i, hV
    if (FCollisionCount > MAX_ETANK_COLLISION_COUNT) or
      (Random < PROBAB_ETANK_RANDOM_TURN) then
      RandomDirection;

    inherited Move; // iU@
  end;
end;

procedure TETank.Draw(Canvas: TCanvas);
begin
  if not Assigned(FStar) then
    inherited Draw(Canvas) // `øsʧ@
  else
    FStar.Draw(Canvas); // eX{{PP
end;

{ TETank1 class }

constructor TETank1.Create;
begin
  inherited Create;

  FScore := 1000;
end;

function TETank1.GetFileName: string;
begin
  Result := AppDir + DR_IMAGES + 'etank1.bmp';
end;

{ TETank2 class }

constructor TETank2.Create;
begin
  inherited Create;
  
  FSpeed := SPRITE_DEFAULT_SPEED * 2; // tׯSO
  FScore := 1200;
end;

function TETank2.GetFileName: string;
begin
  Result := AppDir + DR_IMAGES + 'etank2.bmp';
end;

{ TETank3 class }

constructor TETank3.Create;
begin
  inherited Create;
  
  FScore := 1500;
end;

function TETank3.GetFileName: string;
begin
  Result := AppDir + DR_IMAGES + 'etank3.bmp';
end;

function TETank3.FireBullet: TBullet;
begin
  Result := inherited FireBullet;
  
  if Assigned(Result) then // luSO
    Result.Speed := BULLET_DEFAULT_SPEED * 2;
end;

{ TETank4 class }

constructor TETank4.Create;
begin
  inherited Create;

  FSpeed := SPRITE_DEFAULT_SPEED - 1; // yLC@I
  FScore := 2000;
  FHP := 4; // |U~|
end;

function TETank4.GetFileName: string;
begin
  Result := AppDir + DR_IMAGES + 'etank4.bmp';
end;

{ TETank5 class }

constructor TETank5.Create;
begin
  inherited Create;

  FHP := 10; //  10 U~|, Wr
  FSpeed := SPRITE_DEFAULT_SPEED div 2; // ܺC
  FScore := 10000;
  // SV, |PaΪΩZJۼ (]bŤ)
  FAttr := [saUndirectionalBitmap, saNoCellCollision, saNoTankCollision];
  FOnAir := True; // bŤ
end;

function TETank5.GetFrameMax: Integer;
begin
  Result := 0; // @i
end;

function TETank5.GetFileName: string;
begin
  Result := AppDir + DR_IMAGES + 'etank5.bmp';
end;

function TETank5.GetObjectRect: TRect;
begin
  Result := Classes.Rect(0, 0, 86, 48); // nj"B"~~
end;

{ TExplosion }

constructor TExplosion.Create;
begin
  inherited Create;

  FLeadToOver := False; // |ɭP Game Over
  
  FMoveDelay := 4; // C| frame ~ܤ@
  FSpeed := 0; // 
  FAttr := [saUndirectionalBitmap, saNoCellCollision, saNoTankCollision, saNoBulletCollision]; // SV
  
  FAdvanceFrameMode := afStop; // ʵeN
end;

{ TSmallExplosion }

function TSmallExplosion.GetFrameMax: Integer;
begin
  Result := 4; // i
end;

function TSmallExplosion.GetFileName: string;
begin
  Result := AppDir + DR_IMAGES + 'smexp.bmp';
end;

{ TBigExplosion }

function TBigExplosion.GetFileName: string;
begin
  Result := AppDir + DR_IMAGES + 'bigexp.bmp';
end;

function TBigExplosion.GetFrameMax: Integer;
begin
  Result := 5; // i
end;

function TBigExplosion.GetObjectRect: TRect;
begin
  Result := Classes.Rect(0, 0, 64, 64);
end;

{ TBullet class }

constructor TBullet.Create(ATank: TTank);
begin
  inherited Create;

  FTank := ATank; // OogZJ
  FExplosion := nil;
  FTankBulletNum_Dropped := False;

  // N[J Bullets }C
  SetLength(Bullets, Length(Bullets) + 1);
  Bullets[Length(Bullets) - 1] := Self;
end;

destructor TBullet.Destroy;
var
  I, J: Integer;
begin
  // N Bullets }C
  for I := 0 to Length(Bullets) - 1 do
    if Bullets[I] = Self then
    begin
      DynArrayDelete(Bullets, sizeof(TBullet), I, 1);
      Break;
    end;

  if Assigned(FTank) and not FTankBulletNum_Dropped then
    dec(FTank.FBulletNum); // ZJluƥ

  // Rz
  if Assigned(FExplosion) then FExplosion.Free;

  inherited Destroy;
end;

procedure TBullet.FireExplosion(ExplosionClass: TExplosionClass);
begin
  if Assigned(FExplosion) then Exit; // wgsbzF..

  FExplosion := ExplosionClass.Create; // z
  FExplosion.LoadBits;
  FExplosion.CenterWith(Self);

  if Assigned(FTank) then // YogZJsb
  begin
    dec(FTank.FBulletNum); // ZJluƥ
    FTankBulletNum_Dropped := True;
  end;
end;

procedure TBullet.LocateExplosion(R: TRect);
begin
  if not Assigned(FExplosion) then Exit;
  
  case FDirection of
    drUp: FExplosion.CenterBy(X, R.Bottom);
    drDown: FExplosion.CenterBy(X, R.Top);
    drLeft: FExplosion.CenterBy(R.Right, Y);
    drRight: FExplosion.CenterBy(R.Left, Y);
  end;
end;

function TBullet.CheckCollisions(var X, Y: Integer): Boolean;
begin
  Result := inherited CheckCollisions(X, Y);

  // YeS䥦FF, AˬdO_I䥦lu
  if not Result then
    CheckBulletCollisions(X, Y, Result);
end;

procedure TBullet.CheckBoundCollisions(var X, Y: Integer; var bCollision: Boolean);
begin
  inherited CheckBoundCollisions(X, Y, bCollision);
  
  if bCollision then
  begin
    FireExplosion(TSmallExplosion); // ޵oz
    FExplosion.CenterBy(X + ObjectWidth div 2, Y + ObjectHeight div 2);
  end;
end;

function TBullet.CheckCellCollisions(Layer: Integer; var X, Y: Integer; var bCollision: Boolean): TCellArray;
var
  OrgX, OrgY: Integer;
  I         : Integer;
  ExpRect   : TRect;   // zvTd
begin
  OrgX := X;
  OrgY := Y;
  
  Result := inherited CheckCellCollisions(Layer, X, Y, bCollision);

  if bCollision then
  begin
    I := 0;
    while I < Length(Result) do // MiHqL Cells
      if (taBulletCanPass in Result[I].TileAttr) then
        DynArrayDelete(Result, sizeof(TCell), I, 1)
      else
        Inc(I);

    bCollision := Length(Result) > 0;
    if not bCollision then
    begin
      // `ϸɨc, ӵo͸I..
      X := OrgX;
      Y := OrgY;
      Exit;
    end;
    
    FireExplosion(TSmallExplosion); // ޵oz
    FExplosion.CenterBy(X + ObjectWidth div 2, Y + ObjectHeight div 2);
    
    ExpRect := ObjectRect;
    OffsetRect(ExpRect, X, Y);
    
    if Assigned(FTank) then
      InflateRect(ExpRect, FTank.FBulletBlowRange, FTank.FBulletBlowRange)
    else
      InflateRect(ExpRect, BULLET_DEFAULT_BLOW_RANGE, BULLET_DEFAULT_BLOW_RANGE);
    
    for I := 0 to Length(Result) - 1 do
      if (taCanBreak in Tiles[Result[I].TileNo].Attr) then
      begin
        LocateExplosion(Result[I].Rect);
        Result[I].BreakBy(ExpRect);
      end else if (taFlag in Tiles[Result[I].TileNo].Attr) then
      begin
        Result[I].TileNo := 16; // aXl
        FExplosion.FLeadToOver := True;
      end;
  end;
end;

function TBullet.CheckTankCollisions(var X, Y: Integer; var bCollision: Boolean): TTankArray;
var
  I: Integer;
begin
  Result := inherited CheckTankCollisions(X, Y, bCollision);
  
  if not Assigned(FTank) then Exit; // ۤvZJIF..
  
  if bCollision then
  begin
    for I := 0 to Length(Result) - 1 do
      if (Result[I] <> FTank) and not (saNoBulletCollision in Result[I].Attr) and
        (((Result[I] is TMyTank) and (FTank is TETank)) or
        ((Result[I] is TETank) and (FTank is TMyTank))) then
      begin
        PlaySound(PChar(AppDir + 'bomb.wav'), 0, SND_FILENAME or SND_ASYNC);
        
        FireExplosion(TBigExplosion); // ޵ojz
        
        if Result[I].FSuperMode then continue; // LļҦ
        
        dec(Result[I].FHP); // ͩRO@
        if Result[I].FHP = 0 then // Q쪺ZJ¼F..
        begin
          FExplosion.CenterWith(Result[I]); // ɦbZJz
          Result[I].PostToDie(Result[I].FScore);
        end else
          LocateExplosion(Result[I].Rect); // S, btz
        
        Break; // @ZJNF...
      end;
  end;
end;

function TBullet.CheckBulletCollisions(var X, Y: Integer; var bCollision: Boolean): TBulletArray;
var
  I         : Integer;
  NewRect, R: TRect;  
begin
  if not Assigned(FTank) then Exit; // ۤvZJIF..
  
  NewRect := ObjectRect;
  OffsetRect(NewRect, X, Y);
  
  for I := 0 to Length(Bullets) - 1 do
    if (Self <> Bullets[I]) and Assigned(Bullets[I].FTank) and
      (((Bullets[I].FTank is TMyTank) and (FTank is TETank)) or
      ((Bullets[I].FTank is TETank) and (FTank is TMyTank))) and
      IntersectRect(R, NewRect, Bullets[I].Rect) then
    begin
      PostToDie;
      Bullets[I].PostToDie;
    end;
end;

procedure TBullet.Move;
begin
  if not Assigned(FExplosion) then // ٥z
    inherited Move
  else
  begin
    FExplosion.Move;
    
    if not FExplosion.Active then // z
    begin
      if FExplosion.FLeadToOver then
        PostMessage(0, WM_GAMEOVER, 0, 0)
      else
        FExplosion.Visible := False; // ð_
      // lu
      PostToDie;
    end;
  end;
end;

function TBullet.GetFileName: string;
begin
  Result := AppDir + DR_IMAGES + 'bullet.bmp';
end;

function TBullet.GetFrameMax: Integer;
begin
  Result := 0; // u@i
end;

function TBullet.GetObjectRect: TRect;
begin
  Result := Classes.Rect(0, 0, 16, 16);
end;

procedure TBullet.Draw(Canvas: TCanvas);
begin
  if not Assigned(FExplosion) then // Y`i, heXlu
    inherited Draw(Canvas)
  else
    FExplosion.Draw(Canvas); // _heXz
end;

{ TGem class }

constructor TGem.Create(AGemKind: TGemKind);
begin
  inherited Create;
  
  FGemKind := AGemKind;
  
  FSpeed := 0;
  FAttr := [saUndirectionalBitmap];
  
  Gem := Self;
end;

destructor TGem.Destroy;
begin
  Gem := nil;
  
  inherited Destroy;
end;

function TGem.GetFrameMax: Integer;
begin
  Result := 0; // u@i
end;

// ھ_Ūϧ
function TGem.GetFileName: string;
const
  FileNames: array[TGemKind] of string =
    ('gemClock.bmp', 'gemHat.bmp', 'gemArrow.bmp', 'gemStar.bmp', 'gemBlow.bmp', 'gemApple.bmp');
begin
  Result := AppDir + DR_IMAGES + FileNames[FGemKind];
end;

// ZJBz禡 (, øs, )

procedure MoveTanks;
var
  I: Integer;
begin
  for I := 0 to Length(Tanks) - 1 do
    Tanks[I].Move;
end;

procedure DrawTanks(Canvas: TCanvas; OnAir: Boolean);
var
  I: Integer;
begin
  for I := 0 to Length(Tanks) - 1 do
    if OnAir = Tanks[I].FOnAir then
      Tanks[I].Draw(Canvas);
end;

procedure FreeTanks;
begin
  while Length(Tanks) > 1 do
    Tanks[1].Free;
end;

// luBz禡 (, øs, )

procedure MoveBullets;
var
  I: Integer;
begin
  for I := 0 to Length(Bullets) - 1 do
    Bullets[I].Move;
end;

procedure DrawBullets(Canvas: TCanvas); // øsҦlu
var
  I: Integer;
begin
  for I := 0 to Length(Bullets) - 1 do
    Bullets[I].Draw(Canvas);
end;

procedure FreeBullets;
begin
  while Length(Bullets) > 0 do
    Bullets[0].Free;
end;

procedure FreeBulletsForTank(ATank: TTank);
var
  I: Integer;
begin
  for I := 0 to Length(Bullets) - 1 do
    if Bullets[I].FTank = ATank then
      Bullets[I].FTank := nil;
end;

end.

